/*
 *  _____ _______         _                      _
 * |_   _|__   __|       | |                    | |
 *   | |    | |_ __   ___| |___      _____  _ __| | __  ___ ____
 *   | |    | | '_ \ / _ \ __\ \ /\ / / _ \| '__| |/ / / __|_  /
 *  _| |_   | | | | |  __/ |_ \ V  V / (_) | |  |   < | (__ / /
 * |_____|  |_|_| |_|\___|\__| \_/\_/ \___/|_|  |_|\_(_)___/___|
 *                                _
 *              ___ ___ ___ _____|_|_ _ _____
 *             | . |  _| -_|     | | | |     |  LICENCE
 *             |  _|_| |___|_|_|_|_|___|_|_|_|
 *             |_|
 *
 *   PROGRAMOVÁNÍ  <>  DESIGN  <>  PRÁCE/PODNIKÁNÍ  <>  HW A SW
 *
 * Tento zdrojový kód je součástí výukových seriálů na
 * IT sociální síti WWW.ITNETWORK.CZ
 *
 * Kód spadá pod licenci prémiového obsahu a vznikl díky podpoře
 * našich členů. Je určen pouze pro osobní užití a nesmí být šířen.
 * Více informací na http://www.itnetwork.cz/licence
 */

class Clovek {
    private jmeno: string;
    private vek: number;

    protected prijmeni: string;

    public constructor(jmeno: string, prijmeni: string, vek: number) {
        this.jmeno = jmeno;
        this.prijmeni = prijmeni;
        this.vek = vek;
    }

    public getJmeno(): string {
        return this.jmeno;
    }

    public getVek(): number {
        return this.vek;
    }

    public prejmenovat(noveJmeno: string): void {
        this.jmeno = noveJmeno;
    }

    public vratVypisCloveka(): string {
        return this.jmeno + " " + this.prijmeni + ", " + this.vek + " let.";
    }
}

class Muz extends Clovek {
    private zenaty: boolean;

    public constructor(jmeno: string, prijmeni: string, vek: number, zenaty: boolean) {
        super(jmeno, prijmeni, vek);
        this.zenaty = zenaty;
    }

    public vratVypisCloveka(): string {
        return this.getJmeno() + " " + this.prijmeni + ", " + this.getVek() + " let. Ženatý: " + this.zenaty;
    }
}

class Zena extends Clovek {
    private tehotna: boolean;
    private pocetPorodu: number;
    private vdana: boolean;

    public constructor(jmeno: string, prijmeni: string, vek: number, vdana: boolean = false, tehotna: boolean = false, pocetPorodu: number = 0) {
        super(jmeno, prijmeni, vek);
        this.tehotna = tehotna;
        this.pocetPorodu = pocetPorodu;
        this.vdana = vdana;
    }

    public zmenaPrijmeni(novePrijmeni: string): void {
        this.prijmeni = novePrijmeni;
    }

    public vdat() {
        this.vdana = true;
    }

    public porodit(pocet: number = 1) {
        this.pocetPorodu += pocet;
    }

    public vratVypisCloveka(): string {
        return this.getJmeno() + " " + this.prijmeni + ", " + this.getVek() + " let. Vdaná: " + this.vdana + ", Porodů: " + this.pocetPorodu;
    }
}

let zena = new Zena("Lucie", "Novohradská", 38, false, false);
let muz = new Muz("Pepa", "Petřínský", 42, false);

document.body.innerHTML = zena.vratVypisCloveka() + "\n<br>";
document.body.innerHTML += muz.vratVypisCloveka() + "\n<br>";

zena.vdat();
document.body.innerHTML += zena.vratVypisCloveka() + "\n<br>";
zena.porodit();
document.body.innerHTML += zena.vratVypisCloveka() + "\n<br>";
