/*
 *  _____ _______         _                      _
 * |_   _|__   __|       | |                    | |
 *   | |    | |_ __   ___| |___      _____  _ __| | __  ___ ____
 *   | |    | | '_ \ / _ \ __\ \ /\ / / _ \| '__| |/ / / __|_  /
 *  _| |_   | | | | |  __/ |_ \ V  V / (_) | |  |   < | (__ / /
 * |_____|  |_|_| |_|\___|\__| \_/\_/ \___/|_|  |_|\_(_)___/___|
 *                                _
 *              ___ ___ ___ _____|_|_ _ _____
 *             | . |  _| -_|     | | | |     |  LICENCE
 *             |  _|_| |___|_|_|_|_|___|_|_|_|
 *             |_|
 *
 *   PROGRAMOVÁNÍ  <>  DESIGN  <>  PRÁCE/PODNIKÁNÍ  <>  HW A SW
 *
 * Tento zdrojový kód je součástí výukových seriálů na
 * IT sociální síti WWW.ITNETWORK.CZ
 *
 * Kód spadá pod licenci prémiového obsahu a vznikl díky podpoře
 * našich členů. Je určen pouze pro osobní užití a nesmí být šířen.
 * Více informací na http://www.itnetwork.cz/licence
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var Clovek = /** @class */ (function () {
    function Clovek(jmeno, prijmeni, vek) {
        this.jmeno = jmeno;
        this.prijmeni = prijmeni;
        this.vek = vek;
    }
    Clovek.prototype.getJmeno = function () {
        return this.jmeno;
    };
    Clovek.prototype.getPrijmeni = function () {
        return this.prijmeni;
    };
    Clovek.prototype.getVek = function () {
        return this.vek;
    };
    Clovek.prototype.prejmenovat = function (noveJmeno) {
        this.jmeno = noveJmeno;
    };
    Clovek.prototype.vratVypisCloveka = function () {
        return this.jmeno + " " + this.prijmeni + ", " + this.vek + " let.";
    };
    Clovek.svatba = function (zenich, nevesta) {
        zenich.ozenit(nevesta);
        nevesta.vdat(zenich);
    };
    return Clovek;
}());
var Muz = /** @class */ (function (_super) {
    __extends(Muz, _super);
    function Muz(jmeno, prijmeni, vek, zenaty) {
        var _this = _super.call(this, jmeno, prijmeni, vek) || this;
        _this.zenaty = zenaty;
        return _this;
    }
    Muz.prototype.vratVypisCloveka = function () {
        return this.getJmeno() + " " + this.prijmeni + ", " + this.getVek() + " let. Ženatý: " + this.zenaty + "<br>";
    };
    Muz.prototype.ozenit = function (nevesta) {
        this.zenaty = true;
        this.vManzelstvi = nevesta;
    };
    return Muz;
}(Clovek));
var Zena = /** @class */ (function (_super) {
    __extends(Zena, _super);
    function Zena(jmeno, prijmeni, vek, vdana, tehotna, pocetPorodu) {
        if (vdana === void 0) { vdana = false; }
        if (tehotna === void 0) { tehotna = false; }
        if (pocetPorodu === void 0) { pocetPorodu = 0; }
        var _this = _super.call(this, jmeno, prijmeni, vek) || this;
        _this.tehotna = tehotna;
        _this.pocetPorodu = pocetPorodu;
        _this.vdana = vdana;
        return _this;
    }
    Zena.prototype.zmenaPrijmeni = function (novePrijmeni) {
        this.prijmeni = novePrijmeni;
    };
    Zena.prototype.vdat = function (zenich) {
        this.vdana = true;
        this.vManzelstvi = zenich;
        this.zmenaPrijmeni(zenich.getPrijmeni());
    };
    Zena.prototype.porodit = function (pocet) {
        if (pocet === void 0) { pocet = 1; }
        this.pocetPorodu += pocet;
    };
    Zena.prototype.vratVypisCloveka = function () {
        var vypis = this.getJmeno() + " " + this.prijmeni + ", " + this.getVek() + " let. Vdaná: " + this.vdana + ", Porodů: " + this.pocetPorodu + "<br>";
        if (this.vdana) {
            vypis += "Vdaná za: " + this.vManzelstvi.getJmeno() + " " + this.vManzelstvi.getPrijmeni();
        }
        return vypis;
    };
    return Zena;
}(Clovek));
var lucie = new Zena("Lucie", "Novohradská", 38, false, false, 0);
var pepa = new Muz("Pepa", "Smith", 42, false);
document.body.innerHTML += lucie.vratVypisCloveka() + "<br>";
document.body.innerHTML += pepa.vratVypisCloveka() + "<br>";
Clovek.svatba(pepa, lucie);
document.body.innerHTML += lucie.vratVypisCloveka() + "<br>";
